import { world, Player } from "@minecraft/server";
import { globals } from "./globals";
import { menu } from "./ui";
import { sleep } from "./sleep";
export function suscribeEvents(player) {
    world.afterEvents.playerDimensionChange.subscribe(async (afterEvent) => {
        const camera2DTemp = globals.camera2D;
        if (afterEvent.player instanceof Player) {
            globals.camera2D = 0;
            globals.generateBiome = false;
            const scoreboard = world.scoreboard;
            if (afterEvent.fromDimension == world.getDimension("overworld")) {
                globals.boundryBox = world.getDimension('nether').getEntities().find((entity) => {
                    return entity.typeId === "dv:box";
                });
                // structures.loadNether();
                const x1 = scoreboard.getObjective("netherX")?.getScore("-253403070434");
                const y1 = scoreboard.getObjective("netherY")?.getScore("-253403070434");
                const z1 = scoreboard.getObjective("netherZ")?.getScore("-253403070434");
                const currentPos = scoreboard.getObjective("netherX")?.getScore("-253403070434");
                const netherLeft = scoreboard.getObjective("maxBlockInLeftNether")?.getScore("-253403070434") - 65;
                const netherRight = scoreboard.getObjective("maxBlockInRightNether")?.getScore("-253403070434") + 65;
                if (netherLeft > currentPos || netherRight < currentPos) {
                    const safeZone = { x: x1, y: y1, z: z1 };
                    player.camera.setCamera("minecraft:free", {
                        location: safeZone,
                        easeOptions: { easeTime: 0.15, easeType: "InOutSine" },
                    });
                    await sleep(5);
                    player.teleport(safeZone, { rotation: { x: 0, y: -90 } });
                    scoreboard.getObjective("safeZoneX")?.setScore("-253403070434", x1);
                    scoreboard.getObjective("safeZoneY")?.setScore("-253403070434", y1);
                    scoreboard.getObjective("safeZoneZ")?.setScore("-253403070434", z1);
                    await sleep(2);
                    if (
                        !world.getDimension("nether")?.getBlock({ x: x1, y: y1, z: 139 })?.permutation.getState("portal_axis") &&
                        !world
                            .getDimension("nether")
                            ?.getBlock({ x: x1 + 1, y: y1, z: 139 })
                            ?.permutation.getState("portal_axis")
                    )
                        player.runCommandAsync(
                            `structure load "mystructure:NetherPortal" ${x1 - 1} ${y1 - 1} 138 180_degrees none`
                        );
                    const { x, y, z } = afterEvent.fromLocation;
                    scoreboard.getObjective("netherX")?.setScore("-253403070434", x);
                    scoreboard.getObjective("netherY")?.setScore("-253403070434", y);
                    scoreboard.getObjective("netherZ")?.setScore("-253403070434", z);
                }
            }
            else {
                if (globals.isAlive) {
                    globals.boundryBox = world.getDimension('overworld').getEntities().find((entity) => {
                        return entity.typeId === "dv:box";
                    });
                    // structures.loadBiomes();
                    const x = scoreboard.getObjective("netherX")?.getScore("-253403070434");
                    const y = scoreboard.getObjective("netherY")?.getScore("-253403070434");
                    const z = scoreboard.getObjective("netherZ")?.getScore("-253403070434");
                    scoreboard.getObjective("netherX")?.setScore("-253403070434", afterEvent.fromLocation.x);
                    scoreboard.getObjective("netherY")?.setScore("-253403070434", afterEvent.fromLocation.y);
                    scoreboard.getObjective("netherZ")?.setScore("-253403070434", afterEvent.fromLocation.z);
                    const safeZone = { x: x, y: y, z: z == 138 ? z + 1 : z - 1 };
                    player.camera.setCamera("minecraft:free", {
                        location: safeZone,
                        easeOptions: { easeTime: 0.15, easeType: "InOutSine" },
                    });
                    // await sleep(5);
                    player.teleport(safeZone, { rotation: { x: 0, y: -90 } });
                }
                globals.isAlive = true;
            }
        }
        globals.camera2D = camera2DTemp;
        globals.generateBiome = true;
    });
    world.afterEvents.entityDie.subscribe((afterEvent) => {
        if (afterEvent.deadEntity instanceof Player && afterEvent.deadEntity.dimension.id === "minecraft:nether") {
            const scoreboard = world.scoreboard;
            globals.isAlive = false;
            scoreboard
                .getObjective("netherX")
                ?.setScore("-253403070434", scoreboard.getObjective("safeZoneX")?.getScore("-253403070434"));
            scoreboard
                .getObjective("netherY")
                ?.setScore("-253403070434", scoreboard.getObjective("safeZoneY")?.getScore("-253403070434"));
            scoreboard
                .getObjective("netherZ")
                ?.setScore("-253403070434", scoreboard.getObjective("safeZoneZ")?.getScore("-253403070434"));
        }
    });
    world.afterEvents.pressurePlatePush.subscribe((afterEvent) => {
        const { z } = afterEvent.source.location;
        if (afterEvent.source instanceof Player && z < 138.25)
            menu(player);
    });
}

world.afterEvents.worldInitialize.subscribe(async () => {
    const scoreboard = world.scoreboard;
    if (!scoreboard.getObjective("firstJoin")) {
        const structManager = world.structureManager;
        structManager.place("mystructure:tuto", world.getDimension('overworld'), { x: 10822, y: -59, z: 156 });
        structManager.place("mystructure:firstLoad", world.getDimension('overworld'), { x: 10716, y: -64, z: 137 });

        scoreboard.addObjective("upperDistance", "dummy");
        scoreboard.addObjective("lateralDistance", "dummy");
        scoreboard.addObjective("cam2D", "dummy");
        scoreboard.addObjective("boundryBoxActive", "dummy");

        scoreboard.addObjective("maxBlockInRight", "dummy");
        scoreboard.addObjective("yBlockInRight", "dummy");
        scoreboard.addObjective("yMinBlockInRight", "dummy");
        scoreboard.addObjective("maxBlockInLeft", "dummy");
        scoreboard.addObjective("yBlockInLeft", "dummy");
        scoreboard.addObjective("yMinBlockInLeft", "dummy");

        scoreboard.addObjective("maxBlockInLeftNether", "dummy");
        scoreboard.addObjective("maxBlockInRightNether", "dummy");
        scoreboard.addObjective("netherX", "dummy");
        scoreboard.addObjective("netherY", "dummy");
        scoreboard.addObjective("netherZ", "dummy");

        scoreboard.addObjective("a1", "dummy");
        scoreboard.addObjective("a2", "dummy");
        scoreboard.addObjective("a3", "dummy");
        scoreboard.addObjective("a4", "dummy");
        scoreboard.addObjective("a5", "dummy");
        scoreboard.addObjective("a6", "dummy");
        scoreboard.addObjective("a7", "dummy");
        scoreboard.addObjective("a8", "dummy");
        scoreboard.addObjective("a9", "dummy");
        scoreboard.addObjective("a10", "dummy");
        scoreboard.addObjective("a11", "dummy");
        scoreboard.addObjective("a12", "dummy");
        scoreboard.addObjective("a13", "dummy");
        scoreboard.addObjective("a14", "dummy");
        scoreboard.addObjective("a15", "dummy");
        scoreboard.addObjective("a16", "dummy");
        scoreboard.addObjective("a17", "dummy");
        scoreboard.addObjective("a18", "dummy");
        scoreboard.addObjective("a19", "dummy");
        scoreboard.addObjective("a20", "dummy");
        scoreboard.addObjective("a21", "dummy");

        scoreboard.getObjective("maxBlockInRight")?.setScore("-253403070434", 10716);
        scoreboard.getObjective("yBlockInRight")?.setScore("-253403070434", 133);
        scoreboard.getObjective("yMinBlockInRight")?.setScore("-253403070434", -33);
        scoreboard.getObjective("maxBlockInLeft")?.setScore("-253403070434", 11019);
        scoreboard.getObjective("yBlockInLeft")?.setScore("-253403070434", 132);
        scoreboard.getObjective("yMinBlockInLeft")?.setScore("-253403070434", -33);

        scoreboard.getObjective("maxBlockInLeftNether")?.setScore("-253403070434", 11067);
        scoreboard.getObjective("maxBlockInRightNether")?.setScore("-253403070434", 10606);
        scoreboard.getObjective("netherX")?.setScore("-253403070434", 10853);
        scoreboard.getObjective("netherY")?.setScore("-253403070434", 49);
        scoreboard.getObjective("netherZ")?.setScore("-253403070434", 138);

        scoreboard.getObjective("boundryBoxActive")?.setScore("-253403070434", 0);

        scoreboard.getObjective("a1")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a2")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a3")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a4")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a5")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a6")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a7")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a8")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a9")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a10")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a11")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a12")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a13")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a14")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a15")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a16")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a17")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a18")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a19")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a20")?.setScore("-253403070434", 0);
        scoreboard.getObjective("a21")?.setScore("-253403070434", 0);

        await sleep(20)
        structManager.place("mystructure:firstLoadNether", world.getDimension('nether'), { x: 10606, y: 0, z: 137 });
        structManager.place("mystructure:netherBox", world.getDimension('nether'), { x: 11067, y: 30, z: 142 });
    }
});