import { world } from "@minecraft/server";
import { globals } from "./globals";
let biomes = new Map();
let netherBiomes = new Map();
let biomeGenLockLeft = false;
let bgGenLockLeft = false;
let biomeGenLockRight = false;
let bgGenLockRight = false;
let biomeStructure;
export function loadBiomes() {
    // netherBiomes.clear();
    biomes.set(0, { name: "mystructure:Slime_1_1", left: 130, right: 141, width: 141 });
    biomes.set(1, { name: "mystructure:Slime_1_2", left: 130, right: 142, width: 141 });
    biomes.set(2, { name: "mystructure:Slime_2_1", left: 145, right: 148, width: 122 });
    biomes.set(3, { name: "mystructure:Slime_2_2", left: 145, right: 149, width: 122 });
    biomes.set(4, { name: "mystructure:Volcano_1_1", left: 135, right: 139, width: 137 });
    biomes.set(5, { name: "mystructure:Ice_1_1", left: 155, right: 153, width: 153 });
    biomes.set(6, { name: "mystructure:Ice_1_2", left: 156, right: 152, width: 153 });
    biomes.set(7, { name: "mystructure:Candy_1_1", left: 151, right: 146, width: 125 });
    biomes.set(8, { name: "mystructure:Candy_1_2", left: 151, right: 145, width: 125 });
    biomes.set(9, { name: "mystructure:Mushroom_1_1", left: 132, right: 143, width: 148 });
    biomes.set(10, { name: "mystructure:Mushroom_1_2", left: 132, right: 143, width: 148 });
    biomes.set(11, { name: "mystructure:Mushroom_2_1", left: 136, right: 134, width: 130 });
    biomes.set(12, { name: "mystructure:Mushroom_2_2", left: 137, right: 134, width: 130 });
    biomes.set(13, { name: "mystructure:Taiga_2_1", left: 137, right: 136, width: 108 });
    biomes.set(14, { name: "mystructure:Taiga_2_2", left: 138, right: 136, width: 108 });
    biomes.set(15, { name: "mystructure:Dark_1_1", left: 140, right: 137, width: 131 });
    biomes.set(16, { name: "mystructure:Dark_1_2", left: 141, right: 136, width: 131 });
    biomes.set(17, { name: "mystructure:Ocean_2_1", left: 144, right: 145, width: 121 });
    biomes.set(18, { name: "mystructure:Ocean_2_1", left: 144, right: 142, width: 121 });
    biomes.set(19, { name: "mystructure:Oriental_2_1", left: 147, right: 153, width: 138 });
    biomes.set(20, { name: "mystructure:Oriental_2_2", left: 147, right: 152, width: 138 });
    biomes.set(21, { name: "mystructure:Forest_1_1", left: 150, right: 150, width: 174 });
    biomes.set(22, { name: "mystructure:Forest_1_2", left: 151, right: 151, width: 174 });
    biomes.set(23, { name: "mystructure:Mesa_2_1", left: 140, right: 133, width: 174 });
    biomes.set(24, { name: "mystructure:Mesa_2_2", left: 139, right: 132, width: 174 });
    biomes.set(25, { name: "mystructure:Desert_2_1", left: 155, right: 157, width: 174 });
    biomes.set(26, { name: "mystructure:Desert_2_2", left: 156, right: 156, width: 174 });
    biomes.set(27, { name: "mystructure:Dark_2_1", left: 134, right: 132, width: 174 });
    biomes.set(28, { name: "mystructure:Dark_2_2", left: 135, right: 131, width: 174 });
    biomes.set(29, { name: "mystructure:Savana_1_1", left: 139, right: 132, width: 150 });
    biomes.set(30, { name: "mystructure:Savana_1_2", left: 139, right: 131, width: 150 });
    biomes.set(31, { name: "mystructure:Jungle_1_1", left: 134, right: 132, width: 174 });
    biomes.set(32, { name: "mystructure:Jungle_1_2", left: 133, right: 133, width: 174 });
    biomes.set(33, { name: "mystructure:Ocean_1_1", left: 139, right: 138, width: 101 });
    biomes.set(34, { name: "mystructure:Ocean_1_2", left: 139, right: 139, width: 101 });
    biomes.set(35, { name: "mystructure:Mesa_1_1", left: 132, right: 132, width: 96 });
    biomes.set(36, { name: "mystructure:Desert_1_1", left: 133, right: 133, width: 104 });
    biomes.set(37, { name: "mystructure:Taiga_1_1", left: 133, right: 136, width: 89 });
    biomes.set(38, { name: "mystructure:Oriental_1_1", left: 137, right: 137, width: 134 });
}
export function loadNether() {
    // biomes.clear();
    netherBiomes.set(0, { name: "mystructure:Nether_1", left: 0, right: 0, width: 120 });
    netherBiomes.set(1, { name: "mystructure:Nether_2", left: 0, right: 0, width: 120 });
    netherBiomes.set(2, { name: "mystructure:Nether_3", left: 0, right: 0, width: 81 });
    netherBiomes.set(3, { name: "mystructure:Nether_4", left: 0, right: 0, width: 81 });
    netherBiomes.set(4, { name: "mystructure:Nether_5", left: 0, right: 0, width: 151 });
    netherBiomes.set(5, { name: "mystructure:Nether_6", left: 0, right: 0, width: 151 });
    netherBiomes.set(6, { name: "mystructure:Nether_7", left: 0, right: 0, width: 107 });
    netherBiomes.set(7, { name: "mystructure:Nether_8", left: 0, right: 0, width: 107 });
    netherBiomes.set(8, { name: "mystructure:Nether_9", left: 0, right: 0, width: 111 });
    netherBiomes.set(9, { name: "mystructure:Nether_10", left: 0, right: 0, width: 111 });
    netherBiomes.set(10, { name: "mystructure:Nether_11", left: 0, right: 0, width: 109 });
    netherBiomes.set(11, { name: "mystructure:Nether_12", left: 0, right: 0, width: 109 });
    netherBiomes.set(12, { name: "mystructure:Nether_13", left: 0, right: 0, width: 119 });
    netherBiomes.set(13, { name: "mystructure:Nether_14", left: 0, right: 0, width: 119 });
}
export function generateNetherBiome(player) {
    const x = player.location.x;
    const scoreboard = world.scoreboard;
    const structManager = world.structureManager;
    let id;
    let netherStructure;
    let mapX;
    let biomeEnd;
    if (x > scoreboard.getObjective("maxBlockInLeftNether")?.getScore("-253403070434") - 45) {
        if (!globals.generateBiome)
            return;
        id = Math.floor(Math.random() * netherBiomes.size);
        netherStructure = netherBiomes.get(id);
        mapX = scoreboard.getObjective("maxBlockInLeftNether")?.getScore("-253403070434");
        biomeEnd = mapX + netherStructure?.width;
        structManager.place(netherStructure?.name, world.getDimension('nether'), { x: mapX, y: 0, z: 137 })
        player.runCommandAsync("fill " + mapX + " 6 137 " + biomeEnd + " 127 137 barrier");
        player.runCommandAsync("fill " + mapX + " 6 140 " + biomeEnd + " 127 140 barrier");
        scoreboard.getObjective("maxBlockInLeftNether")?.setScore("-253403070434", biomeEnd);
    }
    else if (x < scoreboard.getObjective("maxBlockInRightNether")?.getScore("-253403070434") + 45) {
        id = Math.floor(Math.random() * netherBiomes.size);
        netherStructure = netherBiomes.get(id);
        mapX = scoreboard.getObjective("maxBlockInRightNether")?.getScore("-253403070434");
        biomeEnd = mapX - netherStructure?.width;
        structManager.place(netherStructure?.name, world.getDimension('nether'), { x: biomeEnd, y: 0, z: 137 })
        player.runCommandAsync("fill " + mapX + " 6 137 " + biomeEnd + " 127 137 barrier");
        player.runCommandAsync("fill " + mapX + " 6 140 " + biomeEnd + " 127 140 barrier");
        scoreboard.getObjective("maxBlockInRightNether")?.setScore("-253403070434", biomeEnd);
    }
}
export function generateBiome(player) {
    if (!globals.generateBiome)
        return;
    const x = player.location.x;
    const scoreboard = world.scoreboard;
    if (x > scoreboard.getObjective("maxBlockInLeft")?.getScore("-253403070434") - 40) {
        const mapX = scoreboard.getObjective("maxBlockInLeft")?.getScore("-253403070434");
        const mapMinY = scoreboard.getObjective("yMinBlockInLeft")?.getScore("-253403070434");
        if (!bgGenLockLeft) {
            bgGenLockLeft = true;
            const mapY = scoreboard.getObjective("yBlockInLeft")?.getScore("-253403070434");
            biomeStructure = biomes.get(Math.floor(Math.random() * biomes.size));
            let pasteY = mapMinY - (biomeStructure?.right - mapY);
            scoreboard.getObjective("yBlockInLeft")?.setScore("-253403070434", biomeStructure?.left);
            scoreboard.getObjective("yMinBlockInLeft")?.setScore("-253403070434", pasteY);
            pasteInit(player, globals.holderL, mapX, pasteY, "left");
        }
        else if (!biomeGenLockLeft && x > mapX - 28) {
            biomeGenLockLeft = true;
            pasteBiome(player, globals.holderL, mapX, mapMinY, "left");
        }
        else if (x > mapX - 5) {
            scoreboard.getObjective("maxBlockInLeft")?.setScore("-253403070434", globals.holderL?.location.x);
            endPasteBiome(player, "left");
            bgGenLockLeft = false;
            biomeGenLockLeft = false;
        }
    }
    else if (x < scoreboard.getObjective("maxBlockInRight")?.getScore("-253403070434") + 40) {
        const mapX = scoreboard.getObjective("maxBlockInRight")?.getScore("-253403070434");
        const mapMinY = scoreboard.getObjective("yMinBlockInRight")?.getScore("-253403070434");
        if (!bgGenLockRight) {
            bgGenLockRight = true;
            const mapY = scoreboard.getObjective("yBlockInRight")?.getScore("-253403070434");
            biomeStructure = biomes.get(Math.floor(Math.random() * biomes.size));
            let pasteY = mapMinY - (biomeStructure?.left - mapY);
            scoreboard.getObjective("yBlockInRight")?.setScore("-253403070434", biomeStructure?.right);
            scoreboard.getObjective("yMinBlockInRight")?.setScore("-253403070434", pasteY);
            pasteInit(player, globals.holderR, mapX, pasteY, "right");
        }
        else if (bgGenLockRight && !biomeGenLockRight && x < mapX + 28) {
            biomeGenLockRight = true;
            pasteBiome(player, globals.holderR, mapX, mapMinY, "right");
        }
        else if (x < mapX + 5) {
            scoreboard.getObjective("maxBlockInRight")?.setScore("-253403070434", globals.holderR?.location.x);
            endPasteBiome(player, "right");
            bgGenLockRight = false;
            biomeGenLockRight = false;
        }
    }
}
function endPasteBiome(player, side) {
    player.runCommandAsync(`function ${side}_end`);
    biomeStructure = undefined;
}
function pasteBiome(player, holder, x, y, side) {
    const structManager = world.structureManager;
    const biomeEnd = side === "left" ? x + biomeStructure?.width : x - biomeStructure?.width;
    if (side === "right")
        holder?.teleport({ x: biomeEnd, y: y, z: 137 });
    structManager.place(biomeStructure?.name, world.getDimension('overworld'), { x: side === "left" ? x : biomeEnd, y: y, z: 138 }, { rotation: "Rotate180"})
    if (side === "left")
        holder?.teleport({ x: biomeEnd, y: y, z: 137 });
}
function pasteInit(player, holder, x, y, side) {
    holder?.teleport({ x: x, y: y + 7, z: 137 });
    player.runCommandAsync(`function ${side}_init`);
}
