import { world, system, Player, MolangVariableMap } from "@minecraft/server";
import { secondPersonViewMenu } from "./ui";
import { globals } from "./globals";
import { sleep } from "./sleep";
const molang = new MolangVariableMap();
function particles1() {
    molang.setFloat("variable.lifetime", 500);
    world.getDimension("overworld")?.spawnParticle("dv:halo", { x: 10835.6, y: -46.85, z: 160 }, molang);
}
function particles2() {
    molang.setFloat("variable.lifetime", 500);
    world.getDimension("overworld")?.spawnParticle("dv:halo", { x: 10828.6, y: -46.85, z: 160 }, molang);
}
export function tutorial(player) {
    player.runCommandAsync('summon chess:ftag "§lWelcome to §g2D Survival" 10853.5 -46.5 156');
    player.runCommandAsync('summon chess:ftag "Go forward to start the tutorial!" 10853.5 -46.8 156');
    player.runCommandAsync('setblock 10850 -64 136 border_block')
    let subscription = world.afterEvents.pressurePlatePush.subscribe(async (event) => {
        if (event.source instanceof Player) {
            if (event.source.location.x > 10834 && event.source.location.x < 10836.5) {
                world.playSound("random.orb", player.location);
                secondPersonViewMenu(player);
                particles2();
                killAllFtags();
                player.runCommand('summon chess:ftag "You will be able to adjust any visuals anytime" 10835 -46.5 157');
                player.runCommand('summon chess:ftag "Step into the next halo to start your adventure!" 10835 -46.8 157');
                player.runCommand("setblock 10828 -47 160 heavy_weighted_pressure_plate");
                await sleep(30);
                particles2();
            }
        }
    });
    let subscription2 = world.afterEvents.pressurePlatePush.subscribe(async (event) => {
        if (event.source instanceof Player) {
            if (event.source.location.x > 10827 && event.source.location.x < 10829.5) {
                killAllFtags();
                molang.setFloat("variable.lifetime", 0);
                world.scoreboard.getObjective("firstJoin")?.setScore("-253403070434", 0);
                player.runCommand("gamemode survival @a");
                player.teleport({ x: 10850, y: 128, z: 138.5 });
                world.setDefaultSpawnLocation({ x: 10850, y: 128, z: 138.5 });
                player.runCommand("gamerule dodaylightcycle true");
                player.runCommand("gamerule domobspawning true");
                player.runCommand("fog @a remove test");
                world.afterEvents.pressurePlatePush.unsubscribe(subscription);
                world.afterEvents.pressurePlatePush.unsubscribe(subscription2);
            }
        }
    });
    return new Promise((resolve) => {
        let interval = system.runInterval(() => {
            if (player.location.x < 10847) {
                killAllFtags();
                const lectern = { x: 10841, y: -47, z: 161 };
                const targetBlock = { x: 10841, y: -41, z: 163 };
                world.playSound("random.orb", player.location);
                player.runCommand('summon chess:ftag "Look at the Lectern" 10841 -46.8 157');
                player.runCommand("setblock 10841 -47 161 minecraft:lectern");
                system.clearRun(interval);
                let interval1 = system.runInterval(async () => {
                    const playerView = player.getBlockFromViewDirection()?.block.location;
                    if (playerView && playerView.x == lectern.x && playerView.y == lectern.y && playerView.z == lectern.z) {
                        player.runCommand("inputpermission set @a movement disabled");
                        killAllFtags();
                        player.runCommand('summon chess:ftag "Perfect! This white box is your §linteraction box" 10841 -46.5 157');
                        player.runCommand('summon chess:ftag "Now look at the target block above you" 10841 -46.8 157');
                        await sleep(30);
                        world.playSound("random.orb", player.location);
                        player.runCommand("setblock 10841 -41 163 target");
                        globals.boundryBoxActive = 1;
                        await sleep(10);
                        system.clearRun(interval1);
                        resolve();
                        let interval2 = system.runInterval(async () => {
                            const playerView = player.getBlockFromViewDirection()?.block.location;
                            if (playerView &&
                                playerView.x == targetBlock.x &&
                                playerView.y == targetBlock.y &&
                                playerView.z == targetBlock.z) {
                                particles1();
                                world.playSound("random.orb", player.location);
                                player.runCommand("inputpermission set @a movement enabled");
                                killAllFtags();
                                player.runCommand('summon chess:ftag "Awesome! This green box shows your §lcurrent vision" 10841 -46.45 157');
                                player.runCommand('summon chess:ftag "Use it as reference to move around" 10841 -46.73 157');
                                player.runCommand('summon chess:ftag "Step into the halo to adjust the camera" 10841 -47 157');
                                player.runCommand("setblock 10835 -47 160 heavy_weighted_pressure_plate");
                                system.clearRun(interval2);
                                await sleep(30);
                                particles1();
                            }
                        }, 25);
                    }
                }, 25);
            }
        }, 5);
    });
}
function killAllFtags() {
    world
        .getDimension("overworld")
        .getEntities()
        .map(async (ent) => {
        if (ent.typeId == "chess:ftag") {
            ent.teleport({ x: 10850, y: 50, z: 238 });
            await sleep(3);
            ent.kill();
        }
    });
}

//# sourceMappingURL=../../_cottaDebug/tutorial.js.map
